#ifndef _CONSERVE_STAMINA_CONSTRAINT_H_
#define _CONSERVE_STAMINA_CONSTRAINT_H_

#include "Common.h"
#include "Constraint.h"

const int CONSERVE_STAMINA_CONSTRAINT_ID = 601;

/**
  Nebenbedingung, Kraft zu sparen. 

  {\small {\bf Quelltext}

  [\URL[Header]{src/ConserveStaminaConstraint.h} | [\URL[Implementierung]{src/ConserveStaminaConstraint.cc}]

  {\bf CVS Informationen zum Interface}
  \begin{verbatim}
  **************************************************
  *
  * Aktueller Stand
  *
  *   $RCSfile: ConserveStaminaConstraint.h,v $
  *   $Revision: 1.9 $
  *   $Date: 1998/08/14 13:20:07 $
  *   $Author: myritz $ 
  *
  **************************************************
  \end{verbatim} }*/
class ConserveStaminaConstraint : public Constraint
{
public:
  /** Konstruktor, der die Id setzt. */
  ConserveStaminaConstraint();

  /** Beschreibung als String fuer die Ausgabe auf einem Terminal. */
  virtual String toString() const;

  /** Legt eine Kopie des Objekts auf dem Heap an und liefert einen Zeiger
      darauf zurueck. */
  virtual StorableObject* copy() const;

  /** Virtueller Destruktor */
  virtual ~ConserveStaminaConstraint();

protected:
  /** Wenn noch gefahrlos Energie verbraucht werden kann, 50, andernfalls
      300 + stamina-abhaengiger Wert. */
  virtual int computeExpectedUtility() const;
};

  
#endif
