
/*
 * Aktueller Stand
 *
 *   $RCSfile: Constraint.cc,v $
 *   $Revision: 1.8 $
 *   $Date: 1998/08/14 13:20:08 $
 *   $Author: myritz $ 
 *
 */
 
#include "Constraint.h"
#include "WorldModel.h"

Constraint::Constraint() : 
  theId( UNDEF_CONSTRAINT_ID ),
  simStepOfUtilityCalculation( UNDEF_INT )
{
}  

int Constraint::expectedUtility() const
{
  if ( simStepOfUtilityCalculation != globalWorldModel->simStep() ) {
    theExpectedUtility = computeExpectedUtility();
    simStepOfUtilityCalculation = globalWorldModel->simStep();
  }
  return theExpectedUtility;
}

int Constraint::computeExpectedUtility() const
{
  return NEUTRAL_UTILITY;
}

StorableObject* Constraint::copy() const {
  return new Constraint( *this );
}

String Constraint::toString() const 
{
  return String( "( Constraint utility: " ) +
    String( expectedUtility() ) + String( " ) " );
}


Constraint::~Constraint()
{
}

