
#include<stdio.h>
#include<string.h>

#include "Message.h"
#include "Exception.h"
#include "Configuration.h"
#include "WorldModel.h"

Message::Message( const String& information ) 
{
  setAllFromString(information);
}

Message::Message() 
{
  theTime = UNDEF_TIME;
}

void Message::setAllFromString(const String& information) 
{
  if( !(information.beginsWith( "(hear") ) ) {
    throwException( ( Exception("Message were incorrect used") ) );
  }
  char message[MAX_MESSAGE];
  char sender[30];
  sscanf( information.cString(), "(hear %ld %s %[^)]", &theTime,
	  sender, message );
  if ( strcmp(sender, "referee") == 0 ) {
    theSenderInfo = REFEREE_ID;
  }
  else if( strcmp(sender, "self") == 0 ) {
    theSenderInfo = SELF_ID;
  }
  else {
    theSenderInfo = UNDEF_TEAM_ID;
  }
  theMessage = String(message);

  if( theSenderInfo == UNDEF_TEAM_ID) {
    parseMessageString();
  }
}

void Message::parseMessageString() {
  int senderinfo;
  char message[MAX_MESSAGE];
  char encodedSenderinfo[MAX_MESSAGE];
  sscanf( theMessage.cString(), "%d %s %[^\n]", &senderinfo, encodedSenderinfo,
    message );
   if( ( senderinfo == globalWorldModel->decode( encodedSenderinfo )) &&
       ( senderinfo == globalConf->ourMessageIdentifier )) {
     theSenderInfo = OUR_TEAM_ID;
     theMessage = String( message );
   }
   else {
     theSenderInfo = THEIR_TEAM_ID;
   }
}



StorableObject* Message::copy() const {
  return new Message( *this );
}


String Message::toString() const 
{
  String output;
  output = String( "( message sender: " ) + String( senderInfo() ) +
        ", time: " + String( time() ) +
        ", message: " + message() + " )";
  return output;
}




