
/*
 * Aktueller Stand
 *
 *   $RCSfile: Options.cc,v $
 *   $Revision: 1.11 $
 *   $Date: 1998/08/14 13:21:02 $
 *   $Author: myritz $ 
 *
 */

#include "Options.h"
#include "InvalidIdException.h"
#include "String.h"
 
Option *getOptionWithId( int optionId )
{
  Option *newOption;
  switch ( optionId ) {
  case UNDEF_OPTION_ID:
    newOption = new Option();
    break;
  case INTERCEPT_BALL_OPTION_ID:
    newOption = new InterceptBallOption();
    break;
  case COLLECT_DATA_OPTION_ID:
    newOption = new CollectDataOption();
    break;
  case GOAL_KICK_OPTION_ID:
    newOption = new GoalKickOption();
    break;
  case GO_TO_BASE_OPTION_ID:
    newOption = new GoToBaseOption();
    break;
  case FORWARD_PASS_OPTION_ID:
    newOption = new ForwardPassOption();
    break;
  case DIRECT_PASS_OPTION_ID:
    newOption = new DirectPassOption();
    break;
  case DRIBBLE_OPTION_ID:
    newOption = new DribbleOption();
    break;
  case CONTROL_BALL_OPTION_ID:
    newOption = new ControlBallOption();
    break;
  case GET_INTO_SPACE_OPTION_ID:
    newOption = new GetIntoSpaceOption();
    break;
  case GOALIE_OPTION_ID:
    newOption = new GoalieOption();
    break;
  default:
    throwException( InvalidIdException("Invalid id in optionWithId.") );
    break;
  }
  return newOption;
}

Array<int> optionIds()
{
  Array<int> ids;
  ids.addObject( INTERCEPT_BALL_OPTION_ID );
  ids.addObject( GO_TO_BASE_OPTION_ID );
  ids.addObject( GET_INTO_SPACE_OPTION_ID );
  ids.addObject( COLLECT_DATA_OPTION_ID );
  ids.addObject( GOAL_KICK_OPTION_ID );
  ids.addObject( FORWARD_PASS_OPTION_ID );
  ids.addObject( DIRECT_PASS_OPTION_ID );
  ids.addObject( DRIBBLE_OPTION_ID );
  ids.addObject( CONTROL_BALL_OPTION_ID );
  ids.addObject( GOALIE_OPTION_ID );
  
  return ids;
}





