
/*
 * Aktueller Stand
 *
 *   $RCSfile: AvoidOffsideConstraint.cc,v $
 *   $Revision: 1.6 $
 *   $Date: 1998/08/14 13:19:57 $
 *   $Author: myritz $ 
 *
 */
 
#include "AvoidOffsideConstraint.h"

#include "WorldModel.h"

AvoidOffsideConstraint::AvoidOffsideConstraint() :
  Constraint()
{
  theId = AVOID_OFFSIDE_CONSTRAINT_ID;
}

int AvoidOffsideConstraint::computeExpectedUtility() const
{
  static double const SAFETY_RANGE = 0.1;
  INFO( Log::CONSTRAINTS, 2, 
    "ENTER AvoidOffsideConstraint::computeExpectedUtility\n" );
  int utility;
  double xDifference = globalWorldModel->situation().offsideLineX() -
      globalWorldModel->player().pos().x();
  if ( globalWorldModel->situation().offsideLineXReliability().get() >
      Reliability::RANDOM ) {
    utility = NEUTRAL_UTILITY;
  } 
  else if ( xDifference < 0 ) {
    utility = globalConf->maxAvoidOffsideUtility;
  }
  else if ( xDifference < SAFETY_RANGE ) {
    utility = (int)( ( SAFETY_RANGE - xDifference ) / SAFETY_RANGE * 
        globalConf->maxAvoidOffsideUtility );
  }
  else {
    utility = NEUTRAL_UTILITY;
  }
  INFO( Log::CONSTRAINTS, 5, "utility: " + String( utility ) + "\n" );
  return utility;
}

StorableObject* AvoidOffsideConstraint::copy() const 
{
  return new AvoidOffsideConstraint( *this );
}

String AvoidOffsideConstraint::toString() const 
{
  return String( "( AvoidOffsideConstraint utility: " ) +
    String( theExpectedUtility ) + String( " ) " );
}


AvoidOffsideConstraint::~AvoidOffsideConstraint()
{
}
