
#include "Configuration.h"
#include "Colouring.h"
#include "Log.h"

int Colouring::globalDecrement = 0;

Colouring::Colouring() 
{ 
  thePlayerColour = 0; 
  theBallColour = 0; 

  thePlayerInc = globalConf->incPlayer;
  theBallInc = globalConf->incBall;
  thePlayerDec = globalConf->decPlayer;
  theBallDec = globalConf->decBall;
}

Colouring& Colouring::incPlayerColour()
{    
  thePlayerColour += thePlayerInc;
  return *this;
}


Colouring& Colouring::incBallColour()
{
  theBallColour += theBallInc; 
  return *this;
}


Colouring& Colouring::reallyDecPlayerColour()
{
  // Steht ein Spieler laenger als 5 Sekunden = 50 Takte an einer
  // Stelle, dann hoeren wir auf, seine Position zu faerben.
  // Dadurch bleibt die Akquirierung flexibel.
  static const int maxPlayerColour = 50 * ( thePlayerInc - thePlayerDec );

  if ( thePlayerColour > 0 ) { 
    thePlayerColour -= thePlayerDec * globalDecrement;
    if ( thePlayerColour > maxPlayerColour ) {
      thePlayerColour = maxPlayerColour;
    }
    else if ( thePlayerColour < 0 ) { 
      thePlayerColour = 0;
    }     
  }
  return *this;
}


Colouring& Colouring::reallyDecBallColour()
{
  if ( theBallColour > 0 ) { 
    theBallColour -= theBallDec * globalDecrement;
    if ( theBallColour < 0 ) { 
      theBallColour = 0;
    }
  }
  return *this;
}


void Colouring::decrementAllColours()
{
  globalDecrement++;
}


void Colouring::setGlobalDecrement(int newGlobalDecrement)
{
  globalDecrement = newGlobalDecrement;
}









































