
#ifndef _COLOURING_H_
#define _COLOURING_H_

/** Ein Colouring Objekt repraesentiert die Faerbung eines Rasterelements 
  fuer Spieler und Ball. Enthaelt also das Online erworbene Wissen eines 
  Agenten ueber ein gewisses Gebiet des Spielfeldes. */

class Colouring{
public:
  /**  Der Konstruktor. Initialisiert die Faerbung des Spielers 
    und des Balles. */
  Colouring();  
  
  /// Erhoeht Spielerfaerbung.
  Colouring& incPlayerColour();
  
  /// Erhoeht Ballfaerbung.
  Colouring& incBallColour();
  
  /// Verringert die Spielerfaerbung.
  Colouring& reallyDecPlayerColour();
  
  /// Verringert die Ballfaerbung.
  Colouring& reallyDecBallColour();
  
  /// Die Spielerfaerbung.
  int playerColour() const { return thePlayerColour; }
  
  /// Die Ballfaerbung.
  int ballColour() const { return theBallColour; }

  /// ?
  static void decrementAllColours();

  /// ?
  static void setGlobalDecrement(int newGlobalDecrement);

private: 
  /// Repraesentiert die Haeufigkeit, wie oft vergessen wurde
  static int globalDecrement;

  /// Der Spieler.
  int thePlayerColour;
  /// Der Ball.
  int theBallColour;

  /// Inkrementwert fuer Spielerfaerbungen ( siehe agent.conf )
  int thePlayerInc;
  ///Inkrementwert fuer Ballfaerbungen siehe ( agent.conf )
  int theBallInc;

  /// Dekrementwert fuer Spielerfaerbungen ( siehe agent.conf )
  int thePlayerDec;
  /// Dekrementwert fuer Ballfaerbungen ( siehe agent.conf )
  int theBallDec;
};

#endif
