
/*
 * Aktueller Stand
 *
 *   $RCSfile: ConserveStaminaConstraint.cc,v $
 *   $Revision: 1.9 $
 *   $Date: 1998/08/14 13:20:06 $
 *   $Author: myritz $ 
 *
 */
 
#include "ConserveStaminaConstraint.h"

#include "WorldModel.h"

ConserveStaminaConstraint::ConserveStaminaConstraint() :
  Constraint()
{
  theId = CONSERVE_STAMINA_CONSTRAINT_ID;
}

int ConserveStaminaConstraint::computeExpectedUtility() const
{
  INFO( Log::CONSTRAINTS, 2, 
    "ENTER ConserveStaminaConstraint::computeExpectedUtility\n" );
  double stamina = globalWorldModel->player().stamina();
  int utility = 0;
  if ( ( stamina != UNDEF_DOUBLE ) && 
       ( stamina < globalConf->conserveStaminaActivation ) ) {
    utility = (int)( ( ( globalConf->conserveStaminaActivation - stamina ) /
                       globalConf->conserveStaminaGradient ) );
    if ( ( utility > globalConf->maxConserveStaminaUtility ) ||
         ( stamina < globalConf->conserveStaminaUtilityIncrease.x() ) ) {
      utility = globalConf->maxConserveStaminaUtility;
    }
  }
  INFO( Log::CONSTRAINTS, 5, "utility: " + String( utility ) +
    ", stamina: " + String( stamina ) + "\n" );
  return utility;
}

StorableObject* ConserveStaminaConstraint::copy() const {
  return new ConserveStaminaConstraint( *this );
}

String ConserveStaminaConstraint::toString() const 
{
  return String( "( ConserveStaminaConstraint utility: " ) +
    String( theExpectedUtility ) + String( " ) " );
}


ConserveStaminaConstraint::~ConserveStaminaConstraint()
{
}
